/* Nano1xx smart CARD used for UART Demo code
   Copyright  Nuvoton(SH) Technology Corp. All rights reserved.  2013/9/30 By WBChen */

/* Please conect NuTiny-EVB-Nano130 pin95 and pin96, LED will flash.*/

#include "nano1xx.h"

uint8_t ByteCnt=0;
uint8_t rx_buff[48];

void SC2_IRQHandler(void)  
{
	if(SC2->ISR&SC_ISR_RDA_IS)
	{
	    rx_buff[ByteCnt]=SC2->RBR;
		ByteCnt++; 
		if(ByteCnt==48)
		{
		    for(ByteCnt=0;ByteCnt<48;ByteCnt++)
			{
				if(rx_buff[ByteCnt]!=ByteCnt)
				    while(1);				// յݳ
			}
			GPIOBITE->GP_BIT6 ^= 1;		    // յȷ˸LED
			for(ByteCnt=0;ByteCnt<48;ByteCnt++) //ջ
                rx_buff[ByteCnt]=0;				
			ByteCnt=0;
		}
	}
}

void Smartcard2_uart_init()
{
	CLK->CLKSEL2 = (CLK->CLKSEL2 & ~CLK_CLKSEL2_SC_MASK) | CLK_CLKSEL2_SC_HIRC;	
	CLK->CLKDIV1 = (CLK->CLKDIV1 & ~CLK_CLKDIV1_SC2_MASK) | (2 << 4);	
	GCR->PA_L_MFP = GCR->PA_L_MFP &~(PA6_MFP_MASK|PA7_MFP_MASK)|(PA7_MFP_SC2_DAT|PA6_MFP_SC2_CLK);	
	CLK->APBCLK|=CLK_APBCLK_SC2_EN;
	SC2->CTL|=SC_CTL_SC_CEN|SC_CTL_SLEN;  //ֹͣλΪ1ETU
	SC2-> UACTL|=SC_UACTL_UA_MODE_EN|SC_UACTL_PBDIS; 	  //ݳ8λ  У飬
	SC2->ALTCTL|=SC_ALTCTL_RX_RST|SC_ALTCTL_TX_RST; 

	SC2->ETUCR=417;  //BAUD  ETUCR = HIRC/((CLKDIV1+1)*BAUD)=12000000/((2+1)*9600)=417

	SC2->IER |= SC_IER_RDA_IE;
	NVIC_EnableIRQ(SC2_IRQn) ; 
}

/* Please conect NuTiny-EVB-Nano130 pin95 and pin96, LED will flash.*/
int32_t main(void)
{
	uint8_t i=0;
	Smartcard2_uart_init();
	GPIOE->PMD    = GPIO_PMD_PMD6_OUTPUT ;
	while(1)
	{
		for(i=0;i<48;i++)
		{
			SC2->THR=i;
			while((SC2->ISR&SC_ISR_TBE_IS)==0);
		}
		{
		   uint32_t delay=1000000;
		   while(delay--);
		}
	}
	
}            


void SystemInit(void)
{
}
